# MATLAB scripts

## Calibration (deprecated)

The calibration calculates the rotaion matrix used by the coordinate transform scripts.
In 'calibrate_8x8', mark the centers of all transducers.
In 'calibrate_4x4', mark only the 16 transducers in the middle.

__NOTE: Since the integration of the calibration scripts in [web interface](https://gitlab.fel.cvut.cz/aa4cc/acouman/webinterface), the MATLAB calibration scripts are no longer used.__

## GUIs (deprecated)

Simple Matlab figure GUIs were used to control the platform.
The platform is now controlled using Python [web interface](https://gitlab.fel.cvut.cz/aa4cc/acouman/webinterface).

## Optimization (deprecated)

MATLAB optimization scripts calculate phase delays for an array of 64 ultrasonic transducers. 

### Levitation

The 'levitation' folder contains scripts for single beam levitation method shown in an article by [Asier Marzo](https://www.nature.com/articles/ncomms9661). To generate the phase delays, run 'solverscript.m'. You must have the 'optimization' folder in your MATLAB path to run this script. 

### Ghost Touch 

The 'ghostTouch' folder contains scripts for creating focused acoustic pressure, similarly to [Ghost Touch](http://doi.acm.org/10.1145/2817721.2817727). To generate the phase delays, use the function 'pressurePoints'. You must have the 'optimization' folder in your MATLAB path to run this script.

__NOTE: All optimization scripts are now rewritten in C++ to be ran on the _Raspberry Pi_, the MATLAB scripts can still be used for verification.__

## Visualization

Use the 'acousticPressureSlice' GUI to visualize the acoustic pressure field generated by the transducers. The GUI allows you to load the phase delays, either from the MATLAB workspace or a .mat file. You can set different slice planes (currently, only planes perpendicular to axes, ie. x = c, y = c or z = c, where c is an arbitrary constant, are supported). You can set the limits of the axes and resolution.

Alternatively, you can use the 'acousticPressure3D' function to calculate the pressure field, and then use function like 'slice' or 'isosurface' to visualize the field. To visualize the phase delays of the transducers, use the 'plotPhases' function.